#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUFSIZE 1024
#define PATHSIZE 2048

void PrepareWork(void);
struct RPROG
{
	char Name[256];
	char ext1[256];
	char ext2[256];
};
struct RPROG *RunnedPrograms;
int ProgramsToRunCnt;
#ifdef _MSC_VER
#include <direct.h>
#include <io.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>

void kasuj(char *path);

void sprawdz(char *path)
{
   struct _stat buf;
   int result, mode;
   result = _stat( path, &buf );
   if( result != 0 )
      return;
   else
   {
	  mode=buf.st_mode & _S_IFDIR;
	  if(mode)
	  {
		  kasuj(path);
		  rmdir(path);
	  }
	  else
		  _unlink(path);
   }

}

void kasuj(char *path)
{
	struct _finddata_t finfo;
	long w;
	char spattern[]="*";
	chdir(path);
	if ((w=_findfirst(spattern,&finfo))!=-1L)
	{
		w=_findfirst(spattern, &finfo);
		if(finfo.name[0]!='.')
			sprawdz(finfo.name);
		while (_findnext(w, &finfo)==0)
		{
			if(finfo.name[0]!='.')
				sprawdz(finfo.name);
		}
	}
	chdir("..");
	_unlink(path);
}

int pliki(void)
{
	struct _finddata_t finfo;
	FILE *designf, *testfile;
	long w;
	int retval=1;
	char spattern[]="*.vhd";
	if ((w=_findfirst(spattern,&finfo))==-1L)
	{
		printf("Error: No source files (*.vhd) in current directory\n");
		return 1;
	}
	else
	{
		PrepareWork();
		designf=fopen("work\\design.dgn", "wt");
		w=_findfirst(spattern, &finfo);
		if((testfile=fopen(finfo.name, "rt"))!=NULL)
		{
			fprintf(designf, "%s\n", finfo.name);
			fclose(testfile);
			retval=0;
		}
		while (_findnext(w, &finfo)==0)
		{
			if((testfile=fopen(finfo.name, "rt"))!=NULL)
			{
				fprintf(designf, "%s\n", finfo.name);
				fclose(testfile);
				retval=0;
			}
		}
		fclose(designf);
		_findclose(w);
	}
	return retval;
}

#else

#include <dir.h>
#include <sys/stat.h>
#include <unistd.h>


int pliki(void)
{
	struct ffblk finfo;
	FILE *designf, *testfile;
	int w, retval=1, atr=0;
	char spattern[]="*.vhd";
	if ((w=findfirst(spattern,&finfo,atr))!=0)
	{
		printf("Error: No source files (*.vhd) in current directory\n");
		return 1;
	}
	else
	{
		PrepareWork();
		designf=fopen("work\\design.dgn", "wt");
		w=findfirst(spattern, &finfo, atr);
		while (!w)
		{
			if((testfile=fopen(finfo.ff_name, "rt"))!=NULL)
			{
				fprintf(designf, "%s\n", finfo.ff_name);
				fclose(testfile);
				retval=0;
			}
			w = findnext(&finfo);
		}
		fclose(designf);
	}
	return retval;
}

#endif

void PrepareWork(void)
{
	FILE *autofile;
#ifdef _MSC_VER
	sprawdz("work");
	mkdir("work");
#else
	system("deltree /Y work");
	mkdir("work", 0);
#endif
	autofile=fopen("work\\config.aut", "wt");
	fprintf(autofile, "vhdllex.exe 1\n");
	fprintf(autofile, "vhdlpars.exe 2\n");
	fprintf(autofile, "anseman.exe 3\n");
	fprintf(autofile, "generato.exe 4\n");
	fprintf(autofile, "jaw.exe 5\n");
	fprintf(autofile, "vhmake.exe 6\n");
	fprintf(autofile, "elim_tmp.exe 7\n");
	fprintf(autofile, "vhmake.exe 8\n");
	fprintf(autofile, "pln.exe 9\n");
	if(ProgramsToRunCnt)
	{
		int len, i=0;
		for(i=0 ; i<ProgramsToRunCnt ; i++)
		{
			len=strlen(RunnedPrograms[i].Name);
			if(len>4)
			{
				if(!stricmp(RunnedPrograms[i].Name+len-4, ".exe"))
					fprintf(autofile, "%s %d\n", RunnedPrograms[i].Name, i+10);
				else
					fprintf(autofile, "%s.exe %d\n", RunnedPrograms[i].Name, i+10);
			}
			else
				fprintf(autofile, "%s.exe %d\n", RunnedPrograms[i].Name, i+10);
		}
	}
	fclose(autofile);
}

int WriteDesign(int argc, char *argv[])
{
	int i, retval=1;
	FILE *designf, *testfile;
	PrepareWork();
	designf=fopen("work\\design.dgn", "wt");
	for(i=1 ; i<argc ; i++)
	{
		if((testfile=fopen(argv[i], "rt"))!=NULL)
		{
			fprintf(designf, "%s\n", argv[i]);
			fclose(testfile);
			retval=0;
		}
	}
	fclose(designf);
	return retval;
}

/* Funkcja wykonujaca analizator leksykalny z odpowiednimi parametrami
* Najprawdopodobniej bedzie konieczne jej umieszczenie w samym analizatorze
* leksykalnym, m.in. w celu unikniecia powtarzania sie numeracji identyfikatorow
*/
int CallLexicalAnalizer(void)
{
	int retval;
	chdir("work");
	retval=system("..\\vhdllex.exe alu.var alu.con");
	return retval;
}

/* Funkcja wywolujaca analizator syntaktyczny, jesli jego wykonanie tworzy jakies
* zmienne, ktorych takie same wartosci moglyby zaklocic prace innych programow lub
* swoja wlasna to takze bedzie konieczne umieszczenie ponizszej funkcji w samym kodzie
* analizatora
*/
int CallSyntaxAnalizer(void)
{
	int retval;
	chdir("work");
	retval=system("..\\vhdlpars.exe");
	return retval;
}

int CallConwerter(void)
{
	char cmdline[BUFSIZE];
	int retval=1;
	chdir("work");
	sprintf(cmdline, "..\\jaw");
	retval=system(cmdline);
	return retval;
}

int CallTmpEliminator(void)
{
	char cmdline[BUFSIZE], bufor[BUFSIZE], token[BUFSIZE], EntityKeyword[BUFSIZE];
	FILE *designf;
	int retval=1;
	chdir("work");
	designf=fopen("topent.idx", "rt");
	if(!designf)
		return -1;
	while(fgets(bufor, BUFSIZE, designf))
	{
		sscanf(bufor, "%s%s", EntityKeyword, token);
		if(stricmp(EntityKeyword,"entity"))
			continue;
		sprintf(cmdline, "..\\elim_tmp %s.bnf %s.boo", token, token);
		//printf("%s\n", cmdline);
		retval=system(cmdline);
		if(retval!=0)
			break;
		retval=0;
	}
	fclose(designf);
	return retval;
}

int CallPragmaReplacer(void)
{
	return 0;
}


int CallPLN(int WasOptimized)
{
	char cmdline[BUFSIZE], bufor[BUFSIZE], token[BUFSIZE], EntityKeyword[BUFSIZE];
	FILE *designf;
	char retval=1;
	chdir("work");
	designf=fopen("topent.idx", "rt");
	if(!designf)
		return -1;
	while(fgets(bufor, BUFSIZE, designf))
	{
		sscanf(bufor, "%s%s", EntityKeyword, token);
		if(stricmp(EntityKeyword,"entity"))
			continue;
		if(WasOptimized)
			sprintf(cmdline, "..\\pln.exe %s.boo %s.onp", token, token);
		else
			sprintf(cmdline, "..\\pln.exe %s.bnf %s.onp", token, token);
		retval=system(cmdline);
		if(retval!=64)
			break;
		retval=0;
	}
	fclose(designf);
	return retval;
}

/* Funkcja wywolujaca analizator semantyczny, posiada on wbudowane instrukcje korzystajace
* z pliku z opisem: "design.dgn" wiec moze byc wywolywany bezposrednio
*/
int CallSemanticAnalizer(void)
{
	int retval;
//	system("cd");
	chdir("..");
	retval=system("anseman");
	return retval;
}

/* Funkcja wywolujaca generator kodu, posiada on wbudowane instrukcje korzystajace
* z pliku z opisem: "design.dgn" wiec moze byc wywolywany bezposrednio
*/
int CallCodeGenerator(void)
{
	int retval=system("Generato alu.con alu.var");
	return retval;
}

int ReadEnv(void)
{
	char envset[256], buf[256];
	FILE *envf;
	strcpy(envset, getenv("VHDLENV"));
	envf=fopen(envset, "rt");
	while(fgets(buf, 256, envf))
	{
		;//printf("%s", buf);
	}
	printf("%s\n", envset);
	fclose(envf);
	return 0;
}

void DeleteLastChar(char *str)
{
	str[strlen(str)-1]=0;
}

int MyGetProjectOpt(int argc, char *argv[])
{
	int retval=0, i;
	FILE *designf, *prjfile, *testfile;
	char bufor[BUFSIZE];
	for(i=1 ; i<argc ; i++)
	{
		if(retval && argv[i+1]!=NULL)
			argv[i]=argv[i+1];
		if(!stricmp(argv[i], "-p"))
		{
			retval=i;
			argv[i]=argv[i+1];
		}
	}
	if(retval)
	{
		PrepareWork();
		designf=fopen("work\\design.dgn", "wt");
		prjfile=fopen(argv[retval], "rt");
		if(!prjfile)
			return -1;
		while (fgets(bufor, BUFSIZE, prjfile))
		{
			DeleteLastChar(bufor);
			if((testfile=fopen(bufor, "rt"))!=NULL)
			{
				fprintf(designf, "%s\n", bufor);
				fclose(testfile);
			}
			else
			{
				fclose(designf);
				fclose(prjfile);
				return -1;
			}
		}
		fclose(designf);
		fclose(prjfile);
	}
	return retval;
}

int MyGetOpt(int argc, char *argv[], char *opt)
{
	int retval=0, i;
	for(i=1 ; i<argc ; i++)
	{
		if(retval && argv[i+1]!=NULL)
			argv[i]=argv[i+1];
		if(!stricmp(argv[i], opt))
		{
			retval=1;
			argv[i]=argv[i+1];
		}
	}
	return retval;
}//MyGetOpt


int GetProgramsToRun(int argc, char *argv[])
{
	int retval=0, i, j, ParamNo, ProgramCnt;
	ParamNo=0;
	for(i=1 ; i<argc ; i++)
	{
		if(retval && argv[i+1]!=NULL)
			argv[i]=argv[i+1];
		if(!stricmp(argv[i], "-m"))
		{
			retval=1;
			ParamNo=i;
			argv[i]=argv[i+1];
		}
	}
	if(retval)
	{
		int k, l;
		j=ParamNo;
		retval=0;
		ProgramCnt=0;
		while(argv[j][0]!='-')
		{
			if(argv[j]==NULL || argv[j+1]==NULL || argv[j+2]==NULL)
				break;
			else
			{
				ProgramCnt++;
				j+=3;
			}
			if(argv[j]==NULL)
				break;
		}
		RunnedPrograms=(struct RPROG*)malloc(ProgramCnt*sizeof(struct RPROG));
		for(k=ParamNo, l=0; l<ProgramCnt ; l++, k+=3)
		{
			strcpy(RunnedPrograms[l].Name, argv[k]);
			strcpy(RunnedPrograms[l].ext1, argv[k+1]);
			strcpy(RunnedPrograms[l].ext2, argv[k+2]);
		}
		retval=ProgramCnt;
	}
	return retval;
}
int RunExternalProgram(int ProgramCnt)
{
	int i;
	char cmdline[BUFSIZE], bufor[BUFSIZE], token[BUFSIZE], EntityKeyword[BUFSIZE];
	FILE *designf;
	char retval=1;
	chdir("work");
	for(i=0 ; i<ProgramCnt ; i++)
	{
		designf=fopen("topent.idx", "rt");
		if(!designf)
			return -1;
		while(fgets(bufor, BUFSIZE, designf))
		{
			sscanf(bufor, "%s%s", EntityKeyword, token);
			if(stricmp(EntityKeyword,"entity"))
				continue;
			sprintf(cmdline, "..\\%s %s.%s %s.%s",
				RunnedPrograms[i].Name,
				token, RunnedPrograms[i].ext1,
				token, RunnedPrograms[i].ext2);
			retval=system(cmdline);
//			if(retval!=64)
//				break;
			retval=0;
		}
		fclose(designf);
		return retval;
	}
	return retval;
}
void WriteConfigFile(int ZeroInStdLogic, int ExtendedEntityDesc, int ArithOperation, int OldFlipFlops)
{
	FILE *cfile;
	cfile=fopen("work\\config.dgn", "wt");
	if(cfile!=NULL)
	{
		fprintf(cfile, "%d\t#1-pelne kodowanie std_logic 0-niektore znaki kodowane za pomoca 0\n", ZeroInStdLogic);
		fprintf(cfile, "%d\t#1-dodatkowy plik z opisem jednostki 0-zwykly opis jednostki\n", ExtendedEntityDesc);
		fprintf(cfile, "%d\t#1-generacja z operatorami arytmetycznymi 0-bez operatorow\n", ArithOperation);
		fprintf(cfile, "%d\t#1-generacja ze starymi przerzutnikami 0-nowe przerzutniki", OldFlipFlops);
		fclose(cfile);
	}

}

void WriteCompilerInformation(void)
{
	FILE *infof;
	char bufor[BUFSIZE];
	int l;
	infof=fopen("version.txt", "rt");
	if(!infof)
		return;
	while(fgets(bufor, BUFSIZE, infof))
	{
		l=strlen(bufor);
		if(bufor[l-1]=='\n')
			bufor[l-1]=0;
		puts(bufor);
	}
	fclose(infof);
	return;
}//WriteCompilerInformation

int main(int argc, char *argv[])
{
	FILE *AutoPlik;
	char StartPath[PATHSIZE];
	int retval, merrnr=0;
	int IsOptimizationOn=0, CodeGeneration=1, SyntaxCheck=1, KeyWait=1,
		ZeroInStdLogic=0, ProjectFile=0, PNotation=0, ExtendedEntityDesc=0,
		ArithOperation=0, OldFlipFlops=0;
	WriteCompilerInformation();
	ProgramsToRunCnt=0;
	RunnedPrograms=NULL;
	if((getcwd(StartPath, PATHSIZE))==NULL)
		merrnr=6;
	/*
	retval=ReadEnv();
	*/
	if((IsOptimizationOn+=MyGetOpt(argc, argv, "-o"))!=0)
		argc--;
	if((ArithOperation+=MyGetOpt(argc, argv, "-a"))!=0)
		argc--;
	if((CodeGeneration-=MyGetOpt(argc, argv, "-c"))==0)
		argc--;
	if((SyntaxCheck-=MyGetOpt(argc, argv, "-s"))==0)
		argc--;
	if((KeyWait-=MyGetOpt(argc, argv, "-k"))==0)
		argc--;
	if((PNotation+=MyGetOpt(argc, argv, "-n"))!=0)
		argc--;
	if((ExtendedEntityDesc+=MyGetOpt(argc, argv, "-e"))!=0)
		argc--;
	if((ZeroInStdLogic+=MyGetOpt(argc, argv, "-l"))!=0)
		argc--;
	if((OldFlipFlops+=MyGetOpt(argc, argv, "-f"))!=0)
		argc--;
	if((ProgramsToRunCnt+=GetProgramsToRun(argc, argv))!=0)
		argc-=(ProgramsToRunCnt*3+1);
	if((ProjectFile+=MyGetProjectOpt(argc, argv))!=0)
		argc=1;//Zapisuje design.dgn w katalogu work jako kopie pliku projektowego
	if(ProjectFile<0)
	{
		printf("Error: Cannot open design file or source files (*.vhd) don't exist\n");
		return 6;
	}
	if(!ProjectFile)
	{
		if(argc<2)
		{
			if(pliki())
			{
				printf("Error: No source files (*.vhd)\n");
				return 6;
			}
		}
		else
		{
			if(WriteDesign(argc, argv))
			{
				printf("Error: No source files (*.vhd)\n");
				return 6;
			}
		}
	}
#if 1
	WriteConfigFile(ZeroInStdLogic, ExtendedEntityDesc, ArithOperation, OldFlipFlops);
	if(!merrnr && CallLexicalAnalizer())
	{
		printf("Error: Lexical analyzer\n");
		merrnr=1;
	}
	else
	{
		retval=0;
		if(SyntaxCheck)
			retval=CallSyntaxAnalizer();
		if(retval)
		{
			printf("Error: Syntax analyzer\n");
			merrnr=2;
		}
		else
		{
			if((retval=CallSemanticAnalizer()))
			{
				if(retval==254)
				{
					merrnr=8;//pakiet kompilowany jako standalone
					printf("Standalone package compilation\n");
				}
				else
				{
					printf("Error: Semantic analyzer\n");
					merrnr=3;
				}
			}
			else
			{
				if(CodeGeneration)
				{
					if(CallCodeGenerator())
					{
						printf("Error: Code generation\n");
						merrnr=4;
					}
					else
					{
						if(CallPragmaReplacer())
						{
							printf("Error: Pragma eliminator\n");
							merrnr=8;
						}
						else
						{
							if(CallConwerter())
							{
								printf("Error: Code converter\n");
								merrnr=5;
							}
							else
							{
								if(IsOptimizationOn)
								{
									if(CallTmpEliminator())
									{
										printf("Error: Temporary variables eliminator\n");
										merrnr=7;
									}
									else
									{
										if(PNotation && CallPLN(1))
										{
											printf("Error: Polish Notation converter\n");
											merrnr=9;
										}
									}

								}
								else
								{
									if(PNotation && CallPLN(0))
									{
										printf("Error: Polish Notation converter\n");
										merrnr=9;
									}
								}
								RunExternalProgram(ProgramsToRunCnt);
							}
						}	
					}
				}
			}
		}
	}
#endif
	if(KeyWait)
		system("pause");
	chdir(StartPath);
	AutoPlik=fopen("file", "wt");
	if(AutoPlik)
	{
		fprintf(AutoPlik, "%d", merrnr);
		fclose(AutoPlik);
	}
	return merrnr;
}